      SUBROUTINE gsmdrive
      INCLUDE "parmeta"
      INCLUDE "parm.tbl"
      INCLUDE "mpp.h"
      INCLUDE "mpif.h"
#include "sp.h"
      INTEGER, PARAMETER :: jam=6+2*(jm-10), lp1=lm+1
      LOGICAL :: run,first,restrt,sigma,noz
      INCLUDE "CTLBLK.comm"
      INCLUDE "LOOPS.comm"
      INCLUDE "MASKS.comm"
      INCLUDE "PHYS.comm"
      INCLUDE "VRBLS.comm"
      INCLUDE "CLDWTR.comm"
      INCLUDE "PVRBLS.comm"
      INCLUDE "ACMCLH.comm"
      INCLUDE "PPTASM.comm"
      COMMON /cmicro_start/ micro_start
      LOGICAL :: micro_start, aeta_01
      LOGICAL, PARAMETER :: print_diag=.TRUE.
      INTEGER, PARAMETER :: itlo=-60, ithi=40, ithilo=ithi-itlo+1,
     &     ithilo_n=ithilo*4, ithilo_qm=ithilo*5, ithilo_qt=ithilo*22
      COMMON /cmicro_stats/ nstats(itlo:ithi,4), qmax(itlo:ithi,5),
     &     qtot(itlo:ithi,22)
      INTEGER :: nstats, nstats_0(itlo:ithi,4)
      REAL :: qmax, qtot, qmax_0(itlo:ithi,5),qtot_0(itlo:ithi,22)
      REAL, SAVE :: thour_print, 
     &     precmax(2),prectot(2),precmax_0(2),prectot_0(2)
      REAL, PARAMETER :: dthour_print=3.     
      COMMON /c_fractions/ f_ice(lm,idim1:idim2,jdim1:jdim2)
     &     ,                    f_rain(lm,idim1:idim2,jdim1:jdim2)
     &     ,                    f_rimef(lm,idim1:idim2,jdim1:jdim2)
      REAL f_ice, f_rain, f_rimef, fice, frain, dum
      REAL, PARAMETER :: epsq=1.e-20, grav=9.81, rhol=1000., t0c=273.15,
     &     t_ice=-10., t_icek=t0c+t_ice, rrhol=1./rhol, climit=1.e-12

      REAL :: arain(myis:myie, myjs:myje)
      REAL :: asnow(myis:myie, myjs:myje)
      REAL :: p_col(myis:myie, myjs:myje, lm) 
      REAL :: qi_col(myis:myie, myjs:myje, lm) 
      REAL :: qr_col(myis:myie, myjs:myje, lm) 
      REAL :: qv_col(myis:myie, myjs:myje, lm) 
      REAL :: qw_col(myis:myie, myjs:myje, lm) 
      REAL :: rimef_col(myis:myie, myjs:myje, lm)
      REAL :: t_col(myis:myie, myjs:myje, lm) 
      REAL :: thick_col(myis:myie, myjs:myje, lm) 
      REAL :: wc_col(myis:myie, myjs:myje, lm) 

      dtph=dtq2                   
      IF (micro_start) THEN
         micro_start=.FALSE.       
         f_ice=0.                  
         f_rain=0.                 
         f_rimef=1.                
         CALL gsmconst (dtph)      
         DO l=1,lm
            IF (aeta(l) .GT. .1) THEN
               aeta_01=.FALSE.
            ELSE
               aeta_01=.TRUE.        
            ENDIF
            DO j=myjs2,myje2
               DO i=myis,myie
                  IF (cwm(i,j,l).LE.climit .OR. aeta_01) cwm(i,j,l)=0.
                  IF (t(i,j,l) .LE. t_icek) f_ice(l,i,j)=1.
               ENDDO
            ENDDO
         ENDDO
         thour_print=-dtph/3600.
         IF (print_diag) THEN
            nstats=0      
            qmax=0.       
            qtot=0.       
            precmax=0.    
            prectot=0.    
         ENDIF
      ENDIF
      DO j=myjs2,myje2
         DO i=myis,myie
            pdsl=pd(i,j)*res(i,j)              
            const=pdsl/grav                    
            IF (cwm(i,j,1) .LE. climit) cwm(i,j,1)=epsq
            f_ice(1,i,j)=1.
            f_rain(1,i,j)=0.
            f_rimef(1,i,j)=1.
            DO l=1,lmh(i,j)
               p_col(i,j,l)=pdsl*aeta(l)+pt
               thick_col(i,j,l)=const*deta(l)
               t_col(i,j,l)=t(i,j,l)
               tc=t_col(i,j,l)-t0c
               qv_col(i,j,l)=MAX(epsq, q(i,j,l))
               IF (cwm(i,j,l) .LE. climit) THEN
                  wc_col(i,j,l)=0.
                  IF (tc .LT. t_ice) THEN
                     f_ice(l,i,j)=1.
                  ELSE
                     f_ice(l,i,j)=0.
                  ENDIF
                  f_rain(l,i,j)=0.
                  f_rimef(l,i,j)=1.
               ELSE
                  wc_col(i,j,l)=cwm(i,j,l)
               ENDIF
               wc=wc_col(i,j,l)
               qi=0.
               qr=0.
               qw=0.
               fice=f_ice(l,i,j)
               frain=f_rain(l,i,j)
               IF (fice .GE. 1.) THEN
                  qi=wc
               ELSE IF (fice .LE. 0.) THEN
                  qw=wc
               ELSE
                  qi=fice*wc
                  qw=wc-qi
               ENDIF
               IF (qw.GT.0. .AND. frain.GT.0.) THEN
                  IF (frain .GE. 1.) THEN
                     qr=qw
                     qw=0.
                  ELSE
                     qr=frain*qw
                     qw=qw-qr
                  ENDIF
               ENDIF
               rimef_col(i,j,l)=f_rimef(l,i,j)               
               qi_col(i,j,l)=qi
               qr_col(i,j,l)=qr
               qw_col(i,j,l)=qw
            ENDDO
            i_index=i
            j_index=j
         ENDDO
      END DO
!      DO j=myjs2,myje2
!         DO i=myis,myie
!            CALL gsmcolumn ( arain(i,j), asnow(i,j), dtph, i_index, 
!     &           j_index, lmh(i,j),
!     &           p_col(i,j,:), qi_col(i,j,:), qr_col(i,j,:), 
!     &           qv_col(i,j,:), qw_col(i,j,:), rimef_col(i,j,:), 
!     &           t_col(i,j,:), 
!     &           thick_col(i,j,:), wc_col(i,j,:))
!         ENDDO
!      END DO

      CALL gsmcolumn (arain, asnow, dtph, lmh, p_col,
     &     qi_col, qr_col, qv_col, qw_col, rimef_col, 
     &     t_col, thick_col, wc_col)


      DO j=myjs2,myje2
         DO i=myis,myie
            DO l=1,lmh(i,j)
               train(i,j,l)=(t_col(i,j,l)-t(i,j,l))/dtph
               t(i,j,l)=t_col(i,j,l)
               q(i,j,l)=qv_col(i,j,l)
               cwm(i,j,l)=wc_col(i,j,l)
               f_rimef(l,i,j)=MAX(1., rimef_col(i,j,l))
               IF (qi_col(i,j,l) .LE. climit) THEN
                  f_ice(l,i,j)=0.
                  IF (t_col(i,j,l) .LT. t_icek) f_ice(l,i,j)=1.
               ELSE
                  f_ice(l,i,j)=MAX( 0., MIN(1., qi_col(i,j,l)/
     &             wc_col(i,j,l)) )
               ENDIF
               IF (qr_col(i,j,l) .LE. climit) THEN
                  dum=0
               ELSE
                  dum=qr_col(i,j,l)/(qr_col(i,j,l)+qw_col(i,j,l))
               ENDIF
               f_rain(l,i,j)=dum
            ENDDO
            aprec(i,j)=(arain(i,j)+asnow(i,j))*rrhol       
            prec(i,j)=prec(i,j)+aprec(i,j)
            acprec(i,j)=acprec(i,j)+aprec(i,j)
            IF(aprec(i,j) .LT. 1.e-8) THEN
               sr(i,j)=0.
            ELSE
               sr(i,j)=rrhol*asnow(i,j)/aprec(i,j)
            ENDIF
            IF (print_diag) THEN
               prectot(1)=prectot(1)+arain(i,j)
               prectot(2)=prectot(2)+asnow(i,j)
               precmax(1)=MAX(precmax(1), arain(i,j))
               precmax(2)=MAX(precmax(2), asnow(i,j))
            ENDIF
         END DO
      END DO
      time_model=float(ntsd-1)*dt/3600.
      IF (print_diag .AND. time_model.GE.thour_print) THEN
         CALL mpi_reduce(nstats,nstats_0,ithilo_n,mpi_integer,mpi_sum,0,
     &        mpi_comm_comp,irtn)
         CALL mpi_reduce(qmax,qmax_0,ithilo_qm,mpi_real,mpi_max,0,
     &        mpi_comm_comp,irtn)
         CALL mpi_reduce(precmax,precmax_0,2,mpi_real,mpi_max,0,
     &        mpi_comm_comp,irtn)
         CALL mpi_reduce(qtot,qtot_0,ithilo_qt,mpi_real,mpi_sum,0,
     &        mpi_comm_comp,irtn)
         CALL mpi_reduce(prectot,prectot_0,2,mpi_real,mpi_sum,0,
     &        mpi_comm_comp,irtn)
         IF (mype .EQ. 0) THEN
            hdtph=3600./dtph            
            DO k=itlo,ithi
               qmax_0(k,1)=1000.*qmax_0(k,1)
               qmax_0(k,2)=1000.*qmax_0(k,2)
               qmax_0(k,3)=1000.*qmax_0(k,3)
               qmax_0(k,4)=hdtph*qmax_0(k,4)
               qmax_0(k,5)=hdtph*qmax_0(k,5)
            ENDDO
            precmax_0(1)=hdtph*precmax_0(1)
            precmax_0(2)=hdtph*precmax_0(2)
            DO k=itlo,ithi
               del_hyd=0.
               DO ii=17,19
                  del_hyd=del_hyd+qtot_0(k,ii)
               ENDDO
               del_qt=0.
               DO ii=16,21
                  del_qt=del_qt+qtot_0(k,ii)
               ENDDO
               IF (qtot_0(k,22) .GT. 0.) THEN
                  rimef_bulk=qtot_0(k,1)/qtot_0(k,22)
               ELSE
                  rimef_bulk=1.
               ENDIF
            ENDDO
         ENDIF
         nstats=0      
         qmax=0.       
         qtot=0.       
         precmax=0.    
         prectot=0.    
         thour_print=thour_print+dthour_print
      ENDIF
      RETURN
 200  FORMAT(a2,i5,f6.2,4(1x,a10,g11.4))
 210  FORMAT(a2,i5,f6.2,4(1x,a10,i7))
      END
